/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MBOX
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_mbox.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_do(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return xcalloc(NMBOXES, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + NMBOXES; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 55

#line 55
static int MBOXTAB_id;
#line 55 "bi_mbox.m4"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < NMBOXES; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}
	
/* number mailbox_open(string url) */
void
#line 68
bi_mailbox_open(eval_environ_t env)
#line 68

#line 68 "bi_mbox.m4"
{
#line 68
	
#line 68

#line 68
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 68
char * url = (char *) get_string_arg(env, 1);
#line 68
        char * mode = (char *) get_string_arg(env, 2);
#line 68
        
#line 68
        adjust_stack(env, __bi_argcnt + 1);
#line 68

#line 68
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 68
		prog_trace(env, "mailbox_open %s %s",url, ((__bi_argcnt > 1) ? mode : ""));;
#line 68

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 78
			env_throw_bi(env, mfe_failure, "mailbox_open", _("No more mailboxes available"))
#line 80
;
	debug1(10, "opening mailbox %s", url);
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags &= ~MU_STREAM_APPEND;
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
					env_throw_bi(env, mfe_range, "mailbox_open", _("Incorrect mode near `%s'"),p);
#line 112
			break;

		default:
				env_throw_bi(env, mfe_range, "mailbox_open", _("Incorrect mode near `%s'"),p);
#line 118
		}
	}
	
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 122
			env_throw_bi(env, mfe_failure, "mailbox_open", _("Cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 125
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
			env_throw_bi(env, mfe_failure, "mailbox_open", _("Cannot open mailbox `%s': %s"),url,mu_strerror(rc));
#line 132
	}
	mu_list_create(&mp->msglist);
	
	
#line 135
do {
#line 135
  push(env, (STKVAL) (md));
#line 135
  return;
#line 135
} while (0);
}
}

/* void mailbox_close(number mbx) */
void
#line 140
bi_mailbox_close(eval_environ_t env)
#line 140

#line 140 "bi_mbox.m4"
{
#line 140
	
#line 140

#line 140

#line 140
long  md = (long ) get_numeric_arg(env, 0);
#line 140
        
#line 140
        adjust_stack(env, 1);
#line 140

#line 140
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 140
		prog_trace(env, "mailbox_close %lu",md);;
#line 140

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < NMBOXES))
#line 144
			env_throw_bi(env, mfe_range, "mailbox_close", _("Invalid mailbox descriptor"))
#line 146
;
	close_mbox(mbtab + md);
}
}

#line 162

	
/* number mailbox_messages_count(number mbx) */
void
#line 165
bi_mailbox_messages_count(eval_environ_t env)
#line 165

#line 165 "bi_mbox.m4"
{
#line 165
	
#line 165

#line 165

#line 165
long  nmbx = (long ) get_numeric_arg(env, 0);
#line 165
        
#line 165
        adjust_stack(env, 1);
#line 165

#line 165
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 165
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 165

{
	size_t count;
	int rc;
	
#line 169
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 169
	struct mf_mbox *mp;
#line 169
			
#line 169
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 169
			env_throw_bi(env, mfe_range, "mailbox_messages_count", _("Invalid mailbox descriptor"))
#line 169
;
#line 169
	mp = mbtab + nmbx;
#line 169
		if (!(mp->mbox))
#line 169
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("Mailbox not open"))
#line 169

#line 169
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 172
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 175
;
	
#line 176
do {
#line 176
  push(env, (STKVAL) (count));
#line 176
  return;
#line 176
} while (0);
}
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 181
bi_mailbox_get_message(eval_environ_t env)
#line 181

#line 181 "bi_mbox.m4"
{
#line 181
	
#line 181

#line 181

#line 181
long  nmbx = (long ) get_numeric_arg(env, 0);
#line 181
        long  msgno = (long ) get_numeric_arg(env, 1);
#line 181
        
#line 181
        adjust_stack(env, 2);
#line 181

#line 181
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 181
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 181

{
	int rc;
	mu_message_t msg;
	
#line 185
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 185
	struct mf_mbox *mp;
#line 185
			
#line 185
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 185
			env_throw_bi(env, mfe_range, "mailbox_get_message", _("Invalid mailbox descriptor"))
#line 185
;
#line 185
	mp = mbtab + nmbx;
#line 185
		if (!(mp->mbox))
#line 185
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("Mailbox not open"))
#line 185

#line 185
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 188
			env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 191
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 193
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("No more message slots available"))
#line 195
;
	
#line 196
do {
#line 196
  push(env, (STKVAL) (rc));
#line 196
  return;
#line 196
} while (0);
}
}


#line 200
void
#line 200
mbox_init_builtin()
#line 200
{
#line 200
	#line 55 "bi_mbox.m4"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes);
#line 68 "bi_mbox.m4"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, 0, dtype_number, 2, 1, 0, dtype_string, dtype_string);
#line 140 "bi_mbox.m4"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 165 "bi_mbox.m4"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 181 "bi_mbox.m4"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, 0, dtype_number, 2, 0, 0, dtype_number, dtype_number);

#line 200 "bi_mbox.m4"
		
#line 200
}
#line 550 "../mfd/snarf.m4"

#line 550

